## meshlab 2020.04+dfsg1

=== src/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

cmake_minimum_required(VERSION 3.9)
project(MeshLab)

# Prefer GLVND
if(POLICY CMP0072)
    cmake_policy(SET CMP0072 NEW)
endif()

### vcglib
if(NOT VCGDIR)
    get_filename_component(VCGDIR "${CMAKE_CURRENT_SOURCE_DIR}/../vcglib" ABSOLUTE)
    if(NOT EXISTS ${VCGDIR})
        set(VCGDIR NOTFOUND)
    endif()
endif()
set(VCGDIR
    "${VCGDIR}"
    CACHE PATH "The location of the vcglib source tree - defaults to sibling of meshlab directory.")

if(NOT VCGDIR)
    message(
        FATAL_ERROR
            "vcglib is required to build MeshLab. Please get the source and set VCGDIR to its location: default location is as a sibling to the meshlab directory above this directory."
    )
endif()

### Build options

option(BUILD_MINI "Build only a minimal set of plugins" OFF)
option(BUILD_STRICT "Strictly enforce resolution of all symbols" ON)
set(BUILD_ADDITIONAL_PLUGINS
    ${BUILD_ADDITIONAL_PLUGINS}
    CACHE
        STRING
        "A list of other plugin subdirectories to recurse into (e.g. select experimental or unsupported plugins) - relative to meshlab/src"
)

option(ALLOW_BUNDLED_EIGEN "Allow use of bundled Eigen source" ON)
option(ALLOW_BUNDLED_GLEW "Allow use of bundled GLEW source" ON)
option(ALLOW_BUNDLED_NEWUOA "Allow use of bundled newuoa source" ON)
option(ALLOW_BUNDLED_LEVMAR "Allow use of bundled levmar source" ON)
option(ALLOW_BUNDLED_LIB3DS "Allow use of bundled lib3ds source" ON)
# option(ALLOW_BUNDLED_MPIR "Allow use of bundled MPIR binaries" ON) # TODO
option(ALLOW_BUNDLED_MUPARSER "Allow use of bundled muparser source" ON)
option(ALLOW_BUNDLED_OPENCTM "Allow use of bundled OpenCTM source" ON)
option(ALLOW_BUNDLED_SSYNTH "Allow use of bundled structure-synth source" ON)
option(ALLOW_BUNDLED_QHULL "Allow use of bundled Qhull source" ON)

option(ALLOW_SYSTEM_EIGEN "Allow use of system-provided Eigen" ON)
option(ALLOW_SYSTEM_GLEW "Allow use of system-provided GLEW" ON)
option(ALLOW_SYSTEM_LIB3DS "Allow use of system-provided lib3ds" ON)
option(ALLOW_SYSTEM_GMP "Allow use of system-provided GMP" ON)
option(ALLOW_SYSTEM_MUPARSER "Allow use of system-provided muparser" ON)
option(ALLOW_SYSTEM_OPENCTM "Allow use of system-provided OpenCTM" ON)
option(ALLOW_SYSTEM_QHULL "Allow use of system-provided QHull" ON)

### Dependencies
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
message(STATUS "Searching for required components")
find_package(OpenGL REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(
    Qt5
    COMPONENTS OpenGL Xml XmlPatterns Script
    REQUIRED)

message(STATUS "Searching for required components with bundled fallback")
find_package(GLEW)
find_package(Eigen3)

message(STATUS "Searching for optional components")
find_package(Lib3ds)
find_package(GMP)
find_package(muparser)
find_package(OpenCTM)
# TODO dynamic qhull that isn't qhull_r is deprecated: port to qhull_r
find_package(Qhull COMPONENTS qhull)
find_package(OpenMP)

if(WIN32)
    option(INSTALL_TO_UNIX_LAYOUT
           "Should the files be installed to a unix layout? If false, they will be installed more like the build tree."
           OFF)

    get_target_property(Qt5_qmake_EXECUTABLE Qt5::qmake IMPORTED_LOCATION)
    get_filename_component(Qt5_BIN_DIR "${Qt5_qmake_EXECUTABLE}" DIRECTORY)
    find_program(
        Qt5_windeployqt_EXECUTABLE
        NAMES windeployqt
        HINTS ${Qt5_BIN_DIR})
    if(Qt5_windeployqt_EXECUTABLE)
        option(BUILD_WITH_WINDEPLOYQT_POST_BUILD
               "Should we run windeployqt after the build to copy the qt parts to the build tree?" ON)
    endif()
else()
    set(INSTALL_TO_UNIX_LAYOUT ON)
endif()

option(INSTALL_SAMPLE_MESHES
       "Should the sample meshes in src/distrib/samples be installed? It will increase the installed size by 14 MiB."
       OFF)
option(
    INSTALL_SAMPLE_RANGEMAPS
    "Should the sample rangemaps in src/distrib/samples/rangemaps be installed? It will increase the installed size by 67 MiB."
    OFF)

### Settings needed for both "external" and internal code
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

### Bundled dependencies in the "external" directory
set(EXTERNAL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external)
include("${CMAKE_CURRENT_SOURCE_DIR}/external.cmake")

### Install directories and build/staging directories
include(GNUInstallDirs)
if(INSTALL_TO_UNIX_LAYOUT)
    set(MESHLAB_BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
    set(MESHLAB_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/meshlab)
    set(MESHLAB_PLUGIN_INSTALL_DIR ${MESHLAB_LIB_INSTALL_DIR}/plugins)
    set(MESHLAB_SHADER_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR}/meshlab/shaders)
    set(MESHLAB_SAMPLE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR}/meshlab)
else()
    set(MESHLAB_BIN_INSTALL_DIR .)
    set(MESHLAB_LIB_INSTALL_DIR .)
    set(MESHLAB_PLUGIN_INSTALL_DIR plugins)
    set(MESHLAB_SHADER_INSTALL_DIR shaders)
    set(MESHLAB_SAMPLE_INSTALL_DIR .)
endif()

set(MESHLAB_BUILD_DISTRIB_DIR ${CMAKE_CURRENT_BINARY_DIR}/distrib)
set(MESHLAB_PLUGIN_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/plugins)
set(MESHLAB_SHADER_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/shaders)
set(MESHLAB_SAMPLE_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/sample)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${MESHLAB_BUILD_DISTRIB_DIR})

### Common build settings for internal code
include_directories(${VCGDIR} ${CMAKE_CURRENT_SOURCE_DIR})

# This gets set to system or local, as appropriate, by external.cmake
include_directories(${EIGEN_INCLUDE_DIRS})

add_definitions(-DMESHLAB_SCALAR=float)

if(BUILD_STRICT AND NOT MSVC)
    # Make sure that our shared libraries were appropriately linked
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

if(WIN32)
    add_definitions(-DNOMINMAX)
    if(MSVC)
        add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    endif()
endif()


### Enter subdirectories
add_subdirectory(common)

set(CMAKE_INSTALL_RPATH $ORIGIN/../${MESHLAB_LIB_INSTALL_DIR};$ORIGIN/../${CMAKE_INSTALL_LIBDIR})
add_subdirectory(meshlab)
add_subdirectory(meshlabserver)
set(CMAKE_INSTALL_RPATH)

### Plugin subdirectories
if(BUILD_MINI)
    # mini
    set(POSSIBLE_PLUGINS
        meshlabplugins/io_base
        meshlabplugins/filter_meshing
        meshlabplugins/decorate_base
        meshlabplugins/filter_measure)
else()
    # full

    set(POSSIBLE_PLUGINS
        # IO plugins
        meshlabplugins/io_3ds
        meshlabplugins/io_base
        meshlabplugins/io_bre
        meshlabplugins/io_collada
        meshlabplugins/io_ctm
        meshlabplugins/io_expe
        meshlabplugins/io_json
        meshlabplugins/io_pdb
        meshlabplugins/io_tri
        meshlabplugins/io_txt
        meshlabplugins/io_u3d
        meshlabplugins/io_x3d


        # Filter plugins
        # meshlabplugins/filter_aging # not in qmake file?
        # meshlabplugins/filter_bnpts # not in qmake file?
        meshlabplugins/filter_ao
        meshlabplugins/filter_camera
        meshlabplugins/filter_clean
        meshlabplugins/filter_color_projection
        meshlabplugins/filter_colorproc
        meshlabplugins/filter_create
        meshlabplugins/filter_csg
        meshlabplugins/filter_dirt
        meshlabplugins/filter_fractal
        meshlabplugins/filter_func
        meshlabplugins/filter_img_patch_param
        meshlabplugins/filter_isoparametrization
        meshlabplugins/filter_layer
        meshlabplugins/filter_measure
        meshlabplugins/filter_meshing
        meshlabplugins/filter_mls
        meshlabplugins/filter_mutualglobal
        meshlabplugins/filter_mutualinfoxml # TODO rename dir - actually named filter_mutualinfo
        meshlabplugins/filter_plymc
        meshlabplugins/filter_qhull
        meshlabplugins/filter_quality
        meshlabplugins/filter_sampling
        meshlabplugins/filter_screened_poisson
        meshlabplugins/filter_sdfgpu
        meshlabplugins/filter_select
        meshlabplugins/filter_sketchfab
        meshlabplugins/filter_ssynth
        meshlabplugins/filter_texture
        meshlabplugins/filter_trioptimize
        meshlabplugins/filter_unsharp
        meshlabplugins/filter_voronoi

        # Rendering and Decoration Plugins
        meshlabplugins/render_gdp
        meshlabplugins/render_radiance_scaling
        meshlabplugins/decorate_base
        meshlabplugins/decorate_background
        meshlabplugins/decorate_raster_proj
        meshlabplugins/decorate_shadow

        # Edit Plugins
        meshlabplugins/edit_align
        # meshlabplugins/edit_hole # not in qmake file?
        meshlabplugins/edit_manipulators
        meshlabplugins/edit_measure
        meshlabplugins/edit_mutualcorrs
        meshlabplugins/edit_paint
        # meshlabplugins/edit_pickpoints # not in qmake file?
        meshlabplugins/edit_point
        meshlabplugins/edit_referencing
        meshlabplugins/edit_quality
        meshlabplugins/edit_select
        # meshlabplugins/edit_slice # not in qmake file?
        # meshlabplugins/edit_texture # not in qmake file?

        # Sample Plugins
        sampleplugins/sampleedit
        sampleplugins/samplefilter
        sampleplugins/samplefilterdyn
        sampleplugins/filter_createiso
        sampleplugins/filter_geodesic
        sampleplugins/sample_filtergpu)
endif()

function(meshlab_install_plugin_xml FN OUTVAR)
    get_filename_component(NAME_ONLY ${FN} NAME)
    set(OUTFN ${MESHLAB_PLUGIN_OUTPUT_DIR}/${NAME_ONLY})
    add_custom_command(
        OUTPUT ${OUTFN}
        COMMAND ${CMAKE_COMMAND} -E make_directory "${MESHLAB_PLUGIN_OUTPUT_DIR}"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different "${FN}" "${OUTFN}"
        COMMENT "Copying ${NAME_ONLY} to plugin build directory"
        VERBATIM)
    install(
        FILES ${FN}
        DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
        COMPONENT Plugins)
    set(${OUTVAR}
        ${OUTFN}
        PARENT_SCOPE)
endfunction()

message(STATUS "\nConfiguring plugins")
foreach(PLUGIN ${POSSIBLE_PLUGINS})
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${PLUGIN}/CMakeLists.txt)
        message(STATUS "- ${PLUGIN}")
        add_subdirectory(${PLUGIN})
    else()
        message(STATUS "  - ${PLUGIN} - Skipping, plugin or build system not found.")
    endif()
endforeach()
if(BUILD_ADDITIONAL_PLUGINS)
    message(STATUS "\nConfiguring plugins specified in BUILD_ADDITIONAL_PLUGINS")
endif()
foreach(PLUGIN ${BUILD_ADDITIONAL_PLUGINS})
    get_filename_component(PLUGIN_DIR ${PLUGIN} ABSOLUTE BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
    if(EXISTS ${PLUGIN_DIR}/CMakeLists.txt)
        message(STATUS "- ${PLUGIN}")
        add_subdirectory(${PLUGIN_DIR})
    else()
        message(FATAL_ERROR "${PLUGIN} - Additional plugin specified in BUILD_ADDITIONAL_PLUGINS but not found.")
    endif()
endforeach()

### Copy/install other files

# This variable keeps track of the output filenames that need to be copied at build time
set(COPIED_FILES)

# shaders
# TODO subdirs?
file(
    GLOB SHADERS
    LIST_DIRECTORIES false
    "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders/*.vert" "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders/*.frag"
    "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders/*.gdp")
foreach(FN ${SHADERS})
    get_filename_component(NAME_ONLY ${FN} NAME)
    set(OUTFN ${MESHLAB_SHADER_OUTPUT_DIR}/${NAME_ONLY})
    add_custom_command(
        OUTPUT ${OUTFN}
        COMMAND ${CMAKE_COMMAND} -E make_directory "${MESHLAB_SHADER_OUTPUT_DIR}"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different "${FN}" "${OUTFN}"
        COMMENT "Copying ${NAME_ONLY} to shader build directory"
        VERBATIM)
    install(
        FILES ${FN}
        DESTINATION ${MESHLAB_SHADER_INSTALL_DIR}
        COMPONENT Shaders)
    list(APPEND COPIED_FILES "${OUTFN}")
endforeach()

# Custom target - to trigger the execution of the custom commands above.

=== src/common/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

if (EXISTS ../../ML_VERSION)
    file(READ ../../ML_VERSION MESHLAB_VERSION)
    add_definitions(-DMESHLAB_VERSION=${MESHLAB_VERSION})
endif()

set(SOURCES
    GLLogStream.cpp
    filterparameter.cpp
    filterscript.cpp
    interfaces.cpp
    meshlabdocumentbundler.cpp
    meshlabdocumentxml.cpp
    meshmodel.cpp
    ml_selection_buffers.cpp
    ml_shared_data_context.cpp
    ml_thread_safe_memory_info.cpp
    mlapplication.cpp
    pluginmanager.cpp
    scriptinterface.cpp
    scriptsyntax.cpp
    searcher.cpp
    xmlfilterinfo.cpp)

set(HEADERS
    GLLogStream.h
    filterparameter.h
    filterscript.h
    interfaces.h
    meshlabdocumentbundler.h
    meshlabdocumentxml.h
    meshmodel.h
    ml_mesh_type.h
    ml_selection_buffers.h
    ml_shared_data_context.h
    ml_thread_safe_memory_info.h
    mlapplication.h
    mlexception.h
    pluginmanager.h
    scriptinterface.h
    scriptsyntax.h
    searcher.h
    xmlfilterinfo.h)

set(RESOURCES common.qrc)

set(TARGET_TYPE SHARED)
if(WIN32)
    set(TARGET_TYPE STATIC)
endif()
add_library(common ${TARGET_TYPE} ${SOURCES} ${HEADERS} ${RESOURCES})

set_target_properties(common PROPERTIES OUTPUT_NAME meshlab-common)
target_link_libraries(
    common
    PUBLIC Qt5::Core
           Qt5::OpenGL
           Qt5::Script
           Qt5::Widgets
           Qt5::Xml
           Qt5::XmlPatterns
           external-glew
    PRIVATE external-jhead)

set_property(TARGET common PROPERTY FOLDER Core)

if(NOT WIN32)
    install(TARGETS common DESTINATION ${MESHLAB_LIB_INSTALL_DIR})
endif()

=== src/meshlabplugins/filter_screened_poisson/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES
    filter_screened_poisson.cpp Src/MarchingCubes.cpp
    # Src/CmdLineParser.cpp
    Src/Factor.cpp Src/Geometry.cpp)

set(HEADERS
    Src/Allocator.h
    Src/Array.h
    Src/BSplineData.h
    Src/BinaryNode.h
    Src/CmdLineParser.h
    Src/Factor.h
    Src/FunctionData.h
    Src/Geometry.h
    Src/Hash.h
    Src/MAT.h
    Src/MarchingCubes.h
    Src/MemoryUsage.h
    Src/MultiGridOctreeData.h
    Src/MyTime.h
    Src/Octree.h
    Src/PPolynomial.h
    Src/PlyVertexMini.h
    Src/PointStream.h
    Src/Polynomial.h
    Src/SparseMatrix.h
    Src/Time.h
    Src/Vector.h
    filter_screened_poisson.h)

set(XML filter_screened_poisson.xml)
meshlab_install_plugin_xml(${CMAKE_CURRENT_SOURCE_DIR}/${XML} XML_OUT)
list(APPEND SOURCES ${XML_OUT})

add_library(filter_screened_poisson MODULE ${SOURCES} ${HEADERS})

target_compile_definitions(filter_screened_poisson PRIVATE BRUNO_LEVY_FIX
                           FOR_RELEASE)

if(OpenMP_CXX_FOUND)
    target_link_libraries(filter_screened_poisson PRIVATE OpenMP::OpenMP_CXX)
endif()

target_include_directories(filter_screened_poisson
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_screened_poisson PUBLIC common)

set_property(TARGET filter_screened_poisson PROPERTY FOLDER Plugins)

set_property(TARGET filter_screened_poisson
             PROPERTY RUNTIME_OUTPUT_DIRECTORY ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_screened_poisson
             PROPERTY LIBRARY_OUTPUT_DIRECTORY ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS filter_screened_poisson DESTINATION
                ${MESHLAB_PLUGIN_INSTALL_DIR} COMPONENT Plugins)

=== debian/changelog ===
meshlab (2020.04+dfsg1-1build1) groovy; urgency=medium

  * No-change rebuild against libqhull7deb1.

 -- Rik Mills <rikmills@kde.org>  Thu, 28 May 2020 09:34:41 +0100

meshlab (2020.04+dfsg1-1) unstable; urgency=medium

  [ Ryan Pavlik ]
  * New upstream version 2020.04+dfsg1
  * Rediff and revise patches:
    - Add 0010-Update-ML_VERSION.patch: Upstream failed to bump their
      version file.
    - Add 0007-Install-icon-to-correct-pixmaps-dir.patch: Upstreamed
      patch was incomplete.
    - Drop 15_qhull.patch: Applied upstream
    - Drop 21_install-common-to-lib-subdir.patch: Applied upstream
    - Drop 26_fix_filter-screened-poisson.patch: Applied upstream
    - Drop 20_Add-desktop-file.patch: Applied upstream
    - Drop 23_icon-install-path.patch: Applied upstream
    - Drop 24_dont_use_build_date_for_ver.patch: Upstream removed this
      build date usage.
    - Add 0011-Fix-typos-in-DAE-code.patch to fix a lintian warning
  * Update lintian overrides: some fixed in upstream release, some patched in
    Debian.

  [ Gürkan Myczko ]
  * Team upload.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 20 Apr 2020 09:16:30 +0200

## meshlab 2020.06+dfsg1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -169,6 +169,9 @@
 set(CMAKE_INSTALL_RPATH $ORIGIN/../${MESHLAB_LIB_INSTALL_DIR};$ORIGIN/../${CMAKE_INSTALL_LIBDIR})
 add_subdirectory(meshlab)
 add_subdirectory(meshlabserver)
+if (WIN32)
+    add_subdirectory(use_cpu_opengl)
+endif()
 set(CMAKE_INSTALL_RPATH)
 
 ### Plugin subdirectories
@@ -218,7 +221,7 @@
         meshlabplugins/filter_meshing
         meshlabplugins/filter_mls
         meshlabplugins/filter_mutualglobal
-        meshlabplugins/filter_mutualinfoxml # TODO rename dir - actually named filter_mutualinfo
+        meshlabplugins/filter_mutualinfo
         meshlabplugins/filter_plymc
         meshlabplugins/filter_qhull
         meshlabplugins/filter_quality
@@ -248,7 +251,7 @@
         meshlabplugins/edit_measure
         meshlabplugins/edit_mutualcorrs
         meshlabplugins/edit_paint
-        # meshlabplugins/edit_pickpoints # not in qmake file?
+        meshlabplugins/edit_pickpoints
         meshlabplugins/edit_point
         meshlabplugins/edit_referencing
         meshlabplugins/edit_quality
@@ -257,12 +260,12 @@
         # meshlabplugins/edit_texture # not in qmake file?
 
         # Sample Plugins
-        sampleplugins/sampleedit
-        sampleplugins/samplefilter
-        sampleplugins/samplefilterdyn
-        sampleplugins/filter_createiso
-        sampleplugins/filter_geodesic
-        sampleplugins/sample_filtergpu)
+        meshlabplugins/edit_sample
+        meshlabplugins/filter_sample
+        meshlabplugins/filter_sample_dyn
+        meshlabplugins/filter_createiso
+        meshlabplugins/filter_geodesic
+        meshlabplugins/filter_sample_gpu)
 endif()
 
 function(meshlab_install_plugin_xml FN OUTVAR)

=== src/common/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,17 @@
-# Copyright 2019 Collabora, Ltd.
+# Copyright 2019-2020, Collabora, Ltd.
 # SPDX-License-Identifier: BSL-1.0
 
-### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py
+### Generated file! Edit the templates in src/templates,
+### specifically src/templates/common.cmake (custom for this directory),
+### then re-run ./make-cmake.py
 
-if (EXISTS ../../ML_VERSION)
-    file(READ ../../ML_VERSION MESHLAB_VERSION)
+if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../../ML_VERSION")
+    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/../../ML_VERSION" MESHLAB_VERSION)
     add_definitions(-DMESHLAB_VERSION=${MESHLAB_VERSION})
 endif()
 
 set(SOURCES
+    GLExtensionsManager.cpp
     GLLogStream.cpp
     filterparameter.cpp
     filterscript.cpp
@@ -27,6 +30,7 @@
     xmlfilterinfo.cpp)
 
 set(HEADERS
+    GLExtensionsManager.h
     GLLogStream.h
     filterparameter.h
     filterscript.h

=== src/meshlab/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/meshlab.cmake (custom for this directory),
### then re-run ./make-cmake.py

set(SOURCES
    additionalgui.cpp
    changetexturename.cpp
    customDialog.cpp
    filterScriptDialog.cpp
    filterthread.cpp
    glarea.cpp
    glarea_setting.cpp
    layerDialog.cpp
    main.cpp
    mainwindow_Init.cpp
    mainwindow_RunTime.cpp
    ml_default_decorators.cpp
    ml_render_gui.cpp
    ml_rendering_actions.cpp
    ml_std_par_dialog.cpp
    multiViewer_Container.cpp
    plugindialog.cpp
    saveSnapshotDialog.cpp
    savemaskexporter.cpp
    stdpardialog.cpp
    xmlgeneratorgui.cpp
    xmlstdpardialog.cpp
    ${VCGDIR}/wrap/gui/trackball.cpp
    ${VCGDIR}/wrap/gui/trackmode.cpp
    ${VCGDIR}/wrap/gui/coordinateframe.cpp)

set(HEADERS
    additionalgui.h
    alnParser.h
    changetexturename.h
    customDialog.h
    filterScriptDialog.h
    filterthread.h
    glarea.h
    glarea_setting.h
    layerDialog.h
    mainwindow.h
    meshlabeditdockwidget.h
    ml_default_decorators.h
    ml_render_gui.h
    ml_rendering_actions.h
    ml_std_par_dialog.h
    multiViewer_Container.h
    plugindialog.h
    saveSnapshotDialog.h
    savemaskexporter.h
    snapshotsetting.h
    stdpardialog.h
    xmlgeneratorgui.h
    xmlstdpardialog.h
    ${VCGDIR}/wrap/gui/trackball.h
    ${VCGDIR}/wrap/gui/trackmode.h
    ${VCGDIR}/wrap/gl/trimesh.h)

set(RESOURCES meshlab.qrc)

set(UI
    ui/aboutDialog.ui
    ui/congratsDialog.ui
    ui/customDialog.ui
    ui/filterScriptDialog.ui
    ui/filtercreatortab.ui
    ui/filtergui.ui
    ui/layerDialog.ui
    ui/renametexture.ui
    ui/savemaskexporter.ui
    ui/savesnapshotDialog.ui)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${CMAKE_CURRENT_SOURCE_DIR}/ui)
#if(APPLE)
#    list(APPEND SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../install/macx/info.plist
#                images/meshlab.icns)
#endif()

if(WIN32)
    list(APPEND SOURCES meshlab.rc)
endif()

add_executable(meshlab WIN32 MACOSX_BUNDLE ${SOURCES} ${HEADERS} ${RESOURCES}
                                           ${UI})

target_compile_definitions(meshlab PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x000000)
target_include_directories(meshlab PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(
    meshlab
    PUBLIC common OpenGL::GLU Qt5::Network
    PRIVATE external-jhead)

set_property(TARGET meshlab PROPERTY FOLDER Core)

install(
    TARGETS meshlab
    DESTINATION ${MESHLAB_BIN_INSTALL_DIR}
    COMPONENT MeshLab)

if(Qt5_windeployqt_EXECUTABLE AND BUILD_WITH_WINDEPLOYQT_POST_BUILD)
    add_custom_command(
        TARGET meshlab
        POST_BUILD
        COMMAND "${Qt5_windeployqt_EXECUTABLE}" --no-translations
                $<TARGET_FILE_NAME:meshlab>
        WORKING_DIRECTORY $<TARGET_FILE_DIR:meshlab>
        COMMENT "Deploying Qt to the build directory of meshlab"
        VERBATIM USES_TERMINAL)
endif()

=== src/meshlabplugins/edit_align/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/edit_align.cmake (custom for this directory),
### then re-run ./make-cmake.py

# Only build if we have newuoa
if(TARGET external-newuoa)

    set(SOURCES
        align/align_parameter.cpp
        align/AlignGlobal.cpp
        align/AlignPair.cpp
        align/OccupancyGrid.cpp
        alignDialog.cpp
        AlignPairDialog.cpp
        AlignPairWidget.cpp
        edit_align_factory.cpp
        edit_align.cpp
        meshtree.cpp
        point_matching_scale.cpp
        ../../meshlab/stdpardialog.cpp
        ${VCGDIR}/wrap/gui/trackball.cpp
        ${VCGDIR}/wrap/gui/trackmode.cpp
        ${VCGDIR}/wrap/ply/plylib.cpp)

    set(HEADERS
        align/align_parameter.h
        align/AlignGlobal.h
        align/AlignPair.h
        align/OccupancyGrid.h
        alignDialog.h
        AlignPairDialog.h
        AlignPairWidget.h
        edit_align_factory.h
        edit_align.h
        meshtree.h
        ../../meshlab/stdpardialog.h
        ${VCGDIR}/wrap/gui/trackball.h
        ${VCGDIR}/wrap/gui/trackmode.h
        ${VCGDIR}/wrap/gl/trimesh.h)

    set(RESOURCES edit_align.qrc)

    set(UI alignDialog.ui)

    add_library(edit_align MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

    target_include_directories(edit_align PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(edit_align PUBLIC common)

    target_link_libraries(edit_align PRIVATE external-newuoa OpenGL::GLU)
    if(OpenMP_CXX_FOUND)
        target_link_libraries(edit_align PRIVATE OpenMP::OpenMP_CXX)
    endif()

    set_property(TARGET edit_align PROPERTY FOLDER Plugins)

    set_property(TARGET edit_align PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

    set_property(TARGET edit_align PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

    install(
        TARGETS edit_align
        DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
        COMPONENT Plugins)

else()
    message(
        STATUS "Skipping edit_align - missing newuoa in external directory.")
endif()

=== src/meshlabplugins/edit_pickpoints/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/CMakeLists.template.cmake (shared with all other directories),
### or create a derived template in src/templates/edit_pickpoints.cmake,
### then re-run ./make-cmake.py

set(SOURCES
    edit_pickpoints_factory.cpp editpickpoints.cpp pickPointsTemplate.cpp
    pickedPoints.cpp pickpointsDialog.cpp ../../meshlab/stdpardialog.cpp)

set(HEADERS edit_pickpoints_factory.h editpickpoints.h pickPointsTemplate.h
            pickedPoints.h pickpointsDialog.h)

set(RESOURCES editpickpoints.qrc)

set(UI pickpointsDialog.ui)

add_library(edit_pickpoints MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

target_include_directories(edit_pickpoints PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_pickpoints PUBLIC common)

target_link_libraries(edit_pickpoints PRIVATE OpenGL::GLU)

set_property(TARGET edit_pickpoints PROPERTY FOLDER Plugins)

set_property(TARGET edit_pickpoints PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_pickpoints PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(
    TARGETS edit_pickpoints
    DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
    COMPONENT Plugins)

=== src/meshlabplugins/edit_referencing/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/edit_referencing.cmake (custom for this directory),
### then re-run ./make-cmake.py

set(SOURCES edit_referencing.cpp edit_referencingDialog.cpp
            edit_referencing_factory.cpp)

set(HEADERS edit_referencing.h edit_referencingDialog.h
            edit_referencing_factory.h)

set(RESOURCES edit_referencing.qrc)

set(UI edit_referencingDialog.ui)

add_library(edit_referencing MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

target_include_directories(edit_referencing PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_referencing PUBLIC common)

target_link_libraries(edit_referencing PRIVATE OpenGL::GLU)

set_property(TARGET edit_referencing PROPERTY FOLDER Plugins)

set_property(TARGET edit_referencing PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                              ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_referencing PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                              ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(
    TARGETS edit_referencing
    DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
    COMPONENT Plugins)

=== src/meshlabplugins/filter_clean/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/filter_clean.cmake (custom for this directory),
### then re-run ./make-cmake.py

set(SOURCES cleanfilter.cpp)

set(HEADERS cleanfilter.h)

add_library(filter_clean MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_clean PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_clean PUBLIC common)

set_property(TARGET filter_clean PROPERTY FOLDER Plugins)

set_property(TARGET filter_clean PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                          ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_clean PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                          ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(
    TARGETS filter_clean
    DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
    COMPONENT Plugins)

=== src/meshlabplugins/filter_isoparametrization/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/filter_isoparametrization.cmake (custom for this directory),
### then re-run ./make-cmake.py

# Only build if we have newuoa and levmar
if(TARGET external-newuoa AND TARGET external-levmar)

    set(SOURCES filter_isoparametrization.cpp)

    set(HEADERS
        defines.h
        diam_parametrization.h
        diam_topology.h
        diamond_sampler.h
        dual_coord_optimization.h
        filter_isoparametrization.h
        iso_parametrization.h
        iso_transfer.h
        local_optimization.h
        local_parametrization.h
        mesh_operators.h
        opt_patch.h
        param_collapse.h
        param_flip.h
        param_mesh.h
        parametrizator.h
        stat_remeshing.h
        statistics.h
        tangent_space.h
        texcoord_optimization.h
        uv_grid.h)

    add_library(filter_isoparametrization MODULE ${SOURCES} ${HEADERS})

    target_include_directories(filter_isoparametrization
                               PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(filter_isoparametrization PUBLIC common)

    target_link_libraries(filter_isoparametrization PRIVATE external-newuoa
                                                            external-levmar)

    if(OpenMP_CXX_FOUND)
        target_link_libraries(filter_isoparametrization
                              PRIVATE OpenMP::OpenMP_CXX)
        target_compile_definitions(filter_isoparametrization PRIVATE _USE_OMP)
    endif()

    set_property(TARGET filter_isoparametrization PROPERTY FOLDER Plugins)

    set_property(TARGET filter_isoparametrization
                 PROPERTY RUNTIME_OUTPUT_DIRECTORY ${MESHLAB_PLUGIN_OUTPUT_DIR})

    set_property(TARGET filter_isoparametrization
                 PROPERTY LIBRARY_OUTPUT_DIRECTORY ${MESHLAB_PLUGIN_OUTPUT_DIR})

    install(
        TARGETS filter_isoparametrization
        DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
        COMPONENT Plugins)

else()
    message(
        STATUS
            "Skipping filter_isoparametrization - missing either newuoa or levmar in external directory."
    )
endif()

=== src/meshlabplugins/filter_sketchfab/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/filter_sketchfab.cmake (custom for this directory),
### then re-run ./make-cmake.py

set(SOURCES filter_sketchfab.cpp ${VCGDIR}/wrap/ply/plylib.cpp)

set(HEADERS filter_sketchfab.h miniz.h)

add_library(filter_sketchfab MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_sketchfab PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_sketchfab PUBLIC common)

set_property(TARGET filter_sketchfab PROPERTY FOLDER Plugins)

set_property(TARGET filter_sketchfab PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                              ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_sketchfab PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                              ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(
    TARGETS filter_sketchfab
    DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
    COMPONENT Plugins)

=== src/meshlabplugins/filter_texture/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/filter_texture.cmake (custom for this directory),
### then re-run ./make-cmake.py

set(SOURCES filter_texture.cpp ${VCGDIR}/wrap/ply/plylib.cpp
            ${VCGDIR}/wrap/qt/outline2_rasterizer.cpp)

set(HEADERS rastering.h filter_texture.h pushpull.h
            ${VCGDIR}/vcg/complex/algorithms/parametrization/voronoi_atlas.h)

add_library(filter_texture MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_texture PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_texture PUBLIC common)

if(MSVC)
    target_compile_definitions(filter_texture PRIVATE _USE_MATH_DEFINES)
endif()

set_property(TARGET filter_texture PROPERTY FOLDER Plugins)

set_property(TARGET filter_texture PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_texture PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(
    TARGETS filter_texture
    DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
    COMPONENT Plugins)

=== src/meshlabplugins/io_u3d/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates,
### specifically src/templates/CMakeLists.template.cmake (shared with all other directories),
### or create a derived template in src/templates/io_u3d.cmake,
### then re-run ./make-cmake.py

set(SOURCES io_u3d.cpp)

set(HEADERS io_u3d.h)

add_library(io_u3d MODULE ${SOURCES} ${HEADERS})

target_include_directories(io_u3d PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(io_u3d PUBLIC common)

set_property(TARGET io_u3d PROPERTY FOLDER Plugins)

set_property(TARGET io_u3d PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                    ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET io_u3d PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                    ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(
    TARGETS io_u3d
    DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
    COMPONENT Plugins)

=== debian/changelog ===
meshlab (2020.06+dfsg1-1) unstable; urgency=medium

 [ Ryan Pavlik ]
  * New upstream version 2020.06+dfsg1
  * d/get-orig-source.sh: Look up hash based on release tag
  * d/copyright: Remove outdated entries in Files-Excluded, add new one
  * d/copyright: Update, fix lintian warnings.
  * d/README.source: Update
  * d/NEWS: Create due to upstream deprecation/migration of plugins affecting
    scripts.
  * Refresh patches.
    - Drop 0010-Update-ML_VERSION.patch: Incorporated upstream.
    - Drop 0011-Fix-typos-in-DAE-code.patch: Incorporated upstream.

 [ Anton Gladky ]
  * [796f34f] Add .gitlab-ci.yml
  * [f2e43fe] Use secure URI in Homepage field.
  * [6ce94fb] Set upstream metadata fields: Bug-Submit.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Mon, 22 Jun 2020 11:25:17 -0500

=== debian/control ===
Source: meshlab
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ryan Pavlik <ryan@ryanpavlik.com>,
           Teemu Ikonen <tpikonen@gmail.com>,
           Gürkan Myczko <gurkan@phys.ethz.ch>
Section: graphics
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               lib3ds-dev,
               libbz2-dev,
               libeigen3-dev,
               libglew-dev,
               libglu1-mesa-dev,
               libgmp-dev,
               libmuparser-dev,
               libopenctm-dev,
               libqhull-dev,
               libqt5opengl5-desktop-dev,
               libqt5xmlpatterns5-dev,
               mesa-common-dev,
               qtbase5-dev,
               qtscript5-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/meshlab
Vcs-Git: https://salsa.debian.org/science-team/meshlab.git
Homepage: https://www.meshlab.net/
Rules-Requires-Root: no

Package: meshlab
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: chemical-mime-data
Description: System for processing and editing triangular meshes
 This is an open source, portable, and extendible system for the
 processing and editing of unstructured 3D triangular meshes.
 The system is aimed to help the processing of the typical not-so-small
 unstructured models arising in 3D scanning, providing a set of tools for
 editing, cleaning, healing, inspecting, rendering and converting this kind
 of meshes.
 .
 Meshlab can read files in these formats: PLY, STL, OFF, OBJ, 3DS, COLLADA
 and PTX. It can write PLY, STL, OFF, OBJ, 3DS, COLLADA, VRML, and DXF.
